// combatd.c

// MudOS v21.6 #pragma optimize's jump threading has bug! (line 200)
//#pragma optimize

#pragma save_binary

#include <ansi.h>
#include <combat.h>

inherit F_CLEAN_UP;
inherit F_DBASE;

string *catch_hunt_msg = ({
	HIW "$NM$nHۨ~Mߨ襴F_ӡT\n" NOR,
	HIW "$N$njܡRuicMSOATv\n" NOR,
	HIW "$NM$n@IMGܤNF_ӡT\n" NOR,
	HIW "$N@h$nMuv@nĤFLӡT\n" NOR,
	HIW "$NܹDRuTO]v\n" NOR,
	HIW "$NܹDRuǩRӡTv\n" NOR,});

void create()
{
	seteuid(getuid());
	set("name", "԰F");
	set("id", "combatd");
}

string damage_msg(int damage, string type)
{
	string str;

//	return "y " + damage + " I" + type + "C\n";

	if( damage == 0 ) return "GSy㪺ˮ`C\n";
	if( damage > 100 ) damage = 100;

	switch( type ) {
	case "":
	case "ζ":
		if( damage < 5 ) return "GuOa}$p֦סC\n";
		else if( damage < 10 ) return "Gb$p$lX@DӪ岪C\n";
		else if( damage < 20 ) return "Guva@nX@DˤfT\n";
		else if( damage < 40 ) return "Guva@nX@DOOˤfT\n";
		else if( damage < 60 ) return "Guva@nX@DSS`ˤfMqo$NyAT\n";
		else return "Guť$n@nGzM$wwb$p$lX@D`ΨiȶˤfTT\n";
		break;
	case "":
		if( damage < 5 ) return "GuOa}$p֦סC\n";
		else if( damage < 10 ) return "Gb$p$lX@ӳФfC\n";
		else if( damage < 20 ) return "GuPva@nJF$n$lo\\T\n";
		else if( damage < 40 ) return "GuPva@ni$n$lM$pѦۥDahFXBT\n";
		else if( damage < 60 ) return "GuPva@nM$wwb$p$lX@ӦUk]KT\n";
		else return "Guť$n@nGzM$wwb$p$lӥXMAqoaTT\n";
		break;
	case "":
		if( damage < 2 ) return "Guԡva@nMiOGˮ`jC\n";
		else if( damage < 5 ) return "Gb$p$ly@BCC\n";
		else if( damage < 10 ) return "G@RM$n$lnɸ~F@ѰT\n";
		else if( damage < 20 ) return "G@RM$neF@nMYFpT\n";
		else if( damage < 40 ) return "Guyva@nM$nhFBT\n";
		else if( damage < 60 ) return "Go@Uuyva@no$nshFnXBMt@ILˡT\n";
		return "GaM$nuzva@nRX@fAT\n";
		break;
	default:
		if( !type ) type = "ˮ`";
		if( damage < 2 ) str =  "GuOjjy@BL";
		else if( damage < 5 ) str = "GyL";
		else if( damage < 10 ) str = "Gy@B";
		else if( damage < 20 ) str = "Gy@BY";
		else if( damage < 30 ) str = "GyᬰY";
		else if( damage < 40 ) str = "Gy۷Y";
		else if( damage < 60 ) str = "GyQY";
		else if( damage < 80 ) str = "GyY";
		else str =  "GyD`iȪY";
		return str + type + "T\n";
	}
}

string eff_status_msg(int ratio)
{
	if( ratio==100 ) return HIG "ݰ_ӮRաMèSˡC" NOR;
	if( ratio > 95 ) return HIG "GFIˡMLq~ݤjXӡC" NOR;
	if( ratio > 90 ) return HIY "ݰ_ӥiFIˡC" NOR;
	if( ratio > 80 ) return HIY "FXBˡMLGäêơC" NOR;
	if( ratio > 60 ) return HIY "ˤMݰ_ӪpäӦnC" NOR;
	if( ratio > 40 ) return HIR "𮧲ʭMʧ@}láMݨөҨ˵۹ꤣC" NOR;
	if( ratio > 30 ) return HIR "wg˲ֲ֡MbjO伵ۤˤUhC" NOR;
	if( ratio > 20 ) return HIR "F۷ˡMuȷ|ͩRMIC" NOR;
	if( ratio > 10 ) return RED "˭UwgH伵MݴNn˦baWC" NOR;
	if( ratio > 5  ) return RED "˹LMwgaa@MRbiFC" NOR;
	return RED "˹LMwgpMHɳi_C" NOR;
}

string status_msg(int ratio)
{
	if( ratio==100 ) return HIC "ݰ_ӥROM@I]֡C" NOR;
	if( ratio > 95 ) return HIC "GǯhΡMOMQOC" NOR;
	if( ratio > 90 ) return CYN "ݰ_ӥi঳ǲ֤FC" NOR;
	if( ratio > 80 ) return CYN "ʧ@G}lIFMOMC" NOR;
	if( ratio > 60 ) return CYN "ݼNNMݰ_ӪpäӦnC" NOR;
	if( ratio > 40 ) return HIB "GQhΡMݨӻݭnnn𮧤FC" NOR;
	if( ratio > 30 ) return HIB "wg@Y}ҼˡMbjO伵ۤˤUhC" NOR;
	if( ratio > 20 ) return HIB "ݰ_ӤwgOqߤFC" NOR;
	if( ratio > 10 ) return BLU "nY̸BnnױצaíMݴNn˦baWC" NOR;
	return BLU "wgJbgAMHɳiL˷whC" NOR;
}

varargs void report_status(object ob, int effective)
{
	if( !ob->query_stat_maximum("kee") ) return;
	if( effective ) 
		message_vision( "( $N" + eff_status_msg(
			(int)ob->query_stat_effective("kee") * 100 / (int)ob->query_stat_maximum("kee") )
			+ " )\n", ob);
	else
		message_vision( "( $N" + status_msg(
			(int)ob->query_stat("kee") * 100 / (int)ob->query_stat_maximum("kee") ) 
			+ " )\n", ob);
}

void do_attack(object me, object victim, object weapon, int type)
{
	int hit_chance;

	hit_chance = 50
		+ (int)me->query_stat("gin") - (int)victim->query_stat("gin");
}

// fight()
//
// This function serves as a lowest level routine for combat system and
// is usually called from a daemon of combat skill such as unarmed, sword
// etc.

varargs int fight(object me, object victim, string skill,
	mapping action, object weapon)
{
	int ability, strength, damage;
	int t_cost;
	int iforce;

	me->set_temp("fight_msg", action["action"] + "M");
	me->set_temp("last_action", action);

	// Strength, affected by force.
	strength = me->query_strength("attack") + action["strength"];
	if( iforce = me->query_skill("force") ) {
		int ratio;
		// Default force ratio is 75%
		if( !(ratio = me->query("force_ratio")) ) ratio = 75;
		if( me->skill_mapped("force")!="force" ) {
			strength += iforce * iforce * (ratio + action["force"]);
			me->consume_stat("kee", iforce * ratio / 1000 + 1);
		}
	}

	// Ability, affected by skill.
	ability = me->query_ability("attack")
		+ me->query_skill(skill)
		+ action["attack"];

	// Time cost.
	t_cost = ((action["time"] ? action["time"] : 7000 )
				+ (weapon ? weapon->weight() : 0))
			/ (ability * 8 );
	if( t_cost < 7 ) t_cost = 7;
	me->act(t_cost);

	// Defense bonus of skill and last action.
	ability -= (victim->query_skill(skill)/2)
		+ victim->query_temp("last_action/defense");
	if( ability < 1 ) ability = 1;

	// General ability jstification
	ability = ability * 6 / 4;

//	message_vision(sprintf("\n[attack %d, strength %d]\n", ability, strength), me);

	if( ability <= (int)victim->resist_attack(ability, strength, weapon ? weapon : me) ) {

		damage = -1;

	} else if( strength <= (int)victim->receive_attack(ability, strength, weapon ? weapon : me) ) {

		damage = 0;
	
	} else { // Failed to parry, inflict some physical damage.

		if( weapon ) damage = weapon->inflict_damage(strength, victim);
		else 		 damage = me->inflict_damage(strength, victim);

		if( damage < 0 )
			me->add_temp("fight_msg", "C\n");
		else {
			me->add_temp("fight_msg",
				damage_msg( damage * 100 / (2 + (int)victim->query_stat_effective("kee")),
					action["damage_type"]));
		}
	}

	{// Generate combat messages.

		string msg = me->query_temp("fight_msg");
		string *limbs = victim->query("limbs");

		if( !arrayp(limbs) || !sizeof(limbs) ) {
//			msg = replace_string(msg, "$l", "");
			msg = replace_string(msg, "$l", "W");
		} else msg = replace_string(msg, "$l", limbs[random(sizeof(limbs))]);
		if( weapon ) msg = replace_string(msg, "$w", weapon->name());
		message_vision(msg, me, victim);
		if( damage > 0 ) report_status(victim, 1);
		message("system", "\n", me);
	}

	return damage;	// > (victim->query_level() - me->query_level()) * 3;
}

//	auto_fight()
//
//	This function is to start an automatically fight. Currently this is
//	used in "aggressive", "vendetta", "hatred", "berserk" fight.
//
void auto_fight(object me, object obj, string type)
{
	// Don't let NPC autofight NPC.
	if( !userp(me) && !userp(obj) ) return;

	// This call_out gives victim a chance to slip trough the fierce guys.
	call_out( "start_" + type, 0, me, obj);
}

void start_hatred(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	if(	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We found our hatred! Charge!
	message_vision( catch_hunt_msg[random(sizeof(catch_hunt_msg))], me, obj);
	me->kill_ob(obj);
	obj->fight_ob(me);
	me->attack();
}

void start_vendetta(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	if(	me->is_fighting(obj)				// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We found our vendetta opponent! Charge!
	me->kill_ob(obj);
	obj->fight_ob(me);
	me->attack();
}

void start_aggressive(object me, object obj)
{
	if( !me || !obj ) return;				// Are we still exist( not becoming a corpse )?

	if(	me->is_fighting()					// Are we busy fighting?
	||	!living(me)							// Are we capable for a fight?
	||	environment(me)!=environment(obj)	// Are we still in the same room?
	||	environment(me)->query("no_fight") 	// Are we in a peace room?
	)	return;

	// We got a nice victim! Kill him/her/it!!!
	me->kill_ob(obj);
	obj->fight_ob(me);
	me->attack();
}

// This function is to announce the special events of the combat.
// This should be moved to another daemon in the future.
void announce(object ob, string event)
{
	switch(event) {
		case "dead":
			message_vision("\n$NFC\n\n", ob);
			break;
		case "unconcious":
			message_vision("\n$N}U@ӤíM^baW@ʤ]ʤFC\n\n", ob);
			break;
		case "revive":
			message_vision("\n$NCCC}MMFLӡC\n\n", ob);
			break;
	}
}

