// acquire.c

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	string skill, who;
	object ob;

	if( !arg || sscanf(arg, "%s from %s", skill, who)!= 2)
		return notify_fail("O榡Racquire <ޯW> from <H>\n");
	if( !objectp(ob = present(who, environment(me))) )
		return notify_fail("ǫSoӤHC\n");
	if( !ob->query_skill(skill, 1) )
		return notify_fail(ob->name() + "ä|oاޯC\n");

	// Produce proper message according to relation between player and teacher.
	if( me->is_apprentice_of(ob) )
		message_vision("$NV$nWY§MqqaDRvbWMDzǱ®{"
			+ "u" + to_chinese(skill) + "vT\n",
			me, ob);
	else if( ob->query("age") > me->query("age") )
		message_vision("$NV$n}UMDR߽" + me->name() + "MeI"
			+ me->rank("self") + "u" + to_chinese(skill) + "vT\n",
			me, ob);
	else
		message_vision("$NV$n§MDRгo" + ob->rank("respectful") 
			+ "I" + me->rank("self") + "u" + to_chinese(skill) + "vT\n",
			me, ob);

	notify_fail("ݰ_" + ob->name() + "QЧAoޯC\n");
	return ob->acquire_skill(me, skill);
}

int help()
{
	write(@TEXT
O榡Racquire <ޯW> from <H>

oӫOiHAVYHuDСvYاޯML@@NЧAMäOAۤv
iHMwMq`ZLHh|aЧAZ\MӥBɭԧYϱЧAM]o|
n۱¡C
TEXT
	);
	return 1;
}
