// enable.c

#include <ansi.h>

inherit F_CLEAN_UP;

mapping valid_types = ([
	"unarmed":	"}",
	"sword":	"Ck",
	"blade":	"Mk",
	"stick":	"Ҫk",
	"staff":	"k",
	"throwing":	"t",
	"force":	"\\",
	"parry":	"۬[",
	"dodge":	"\\",
	"magic":	"kN",
	"spells":	"G",
	"move":		"",
	"array":	"}k",
    "whip":     "@k",
]);

void create() { seteuid(getuid()); }

int main(object me, string arg)
{
	mapping map;
	string *types, *skill, ski, map_to;
	int i, modify;


	if( !arg ) {
		map = me->query_skill_map();
		if( !mapp(map) ) map = ([]);

		skill = keys(valid_types);
		write("HUOAثeϥΤSޯC\n");
		for (i=0; i<sizeof(skill); i++) {
			if( undefinedp(valid_types[skill[i]]) ) {
				map_delete(map, skill[i]);
				continue;
			}
			// if( !me->query_skill(skill[i]) ) continue;
			modify = me->query_temp("apply/" + skill[i]);
			printf("  %-20sR %-20s  ĵšR%s%3d\n" NOR, 
				valid_types[skill[i]] + " (" + skill[i] + ")",
				undefinedp(map[skill[i]]) ? "L" : (map[skill[i]]? to_chinese(map[skill[i]]) : "ϥ"),
				(modify==0 ? "" : (modify>0 ? HIC : HIR)),
				me->query_skill(skill[i]));
		}
		return 1;
	}

	if( arg=="?" ) {
		write("HUOiHϥίSޯ઺R\n");
		skill = sort_array(keys(valid_types), (: strcmp :) );
		for(i=0; i<sizeof(skill); i++) {
			printf("  %s (%s)\n", valid_types[skill[i]], skill[i] );
		}
		return 1;
	}

	if( sscanf(arg, "%s %s", ski, map_to)==2 ) {
		if( undefinedp(valid_types[ski]) )
			return notify_fail("SoӧޯM enable ? iHdݦǺC\n");

		if( map_to=="none" ) {
			me->map_skill(ski, "none");
			write("Ok.\n");
			return 1;
		} else if( map_to==ski ) {
			write("u" + to_chinese(ski) + "vOҦ" + valid_types[ski] + "¦Mݭn enableC\n");
			return 1;
		}

		if( !me->query_skill(map_to, 1) && !me->query_learn(map_to) )
			return notify_fail("A|oاޯC\n");

		if( !SKILL_D(map_to)->valid_enable(ski) )
			return notify_fail("oӧޯणoإγ~C\n");

		me->map_skill(ski, map_to);
		write("Ok.\n");
	}
	me->map_skill(arg);
	write("Ok.\n");
	
	return 1;
}
int help(object me)
{
        write(@HELP
O榡 : enable <ޯ> <ޯW>         <- ϥίSޯBZN
           enable <ޯ> none               <- ϥΦ@ޯ
           enable <ޯ>                    <- uΰ򥻧ޯ
           enable ?

oӫOAwҭnΪޯMݫޯMޯW١CpG[
ƫh|ܥXޯΧAثeҨϥΪޯW MpG[@ ? |CX
ҦϥίSޯ઺ޯC
 
HELP
        );
        return 1;
}
