// get.c
#pragma save_binary

#include <ansi.h>

inherit F_CLEAN_UP;

string *spec_item = ({
	"/d/snow/npc/obj/syndicator",
	"/d/snow/npc/obj/slasher_sword"
});

int do_get(object me, object ob);

void create() {seteuid(getuid());}

int main(object me, string arg)
{
	string from, item;
	object obj, *inv, env, obj2;
	int i, amount;

	if( !arg ) return notify_fail("An߰_FS\n");
	if( me->is_busy() )
		return notify_fail("AW@Ӱʧ@٨ST\n");

	if( !me->query_stat_maximum("kee") )
		return notify_fail("ASMLkB~C\n");

	// Check if a container is specified.
	if( sscanf(arg, "%s from %s", arg, from)==2 ) {
		env = present(from, me);
		if(!env) env = present(from, environment(me));
		if(!env) return notify_fail("A䤣 " + from + " o˪FC\n");
		if(living(env) && (wiz_level(me) <= wiz_level(env)))
			return notify_fail("AŮvť谪M~jC\n");
	} else env = environment(me);

	// Check if a certain amount is specified.
	if(sscanf(arg, "%d %s", amount, item)==2) {
		if( !objectp(obj = present(item, env)) )
			return notify_fail("ǫSo˪FC\n");
		if( !obj->query_amount() )
			return notify_fail( obj->name() + "Q}C\n");
		if( amount < 1 )
			return notify_fail("F誺ӼƦܤ֬O@ӡC\n");
		if( amount > obj->query_amount() )
			return notify_fail("ǫSh" + obj->name() + "C\n");
		else if( amount == (int)obj->query_amount() ) {
			return do_get(me, obj);
		} else {
			obj->set_amount( (int)obj->query_amount() - amount );
			seteuid(MUDLIB_UID);
			obj2 = new(base_name(obj));
			seteuid(getuid());;
			obj2->move(env);			// For containers.
			obj2->set_amount(amount);
			// Counting precise amount costs more time.
			if( me->is_fighting() ) me->start_busy(3);
			return do_get(me, obj);
		}
	}

	// Check if we are makeing a quick get.
	if(arg=="all") {
		if( me->is_fighting() )	return notify_fail("A٦b԰Tu@@ˡC\n");
		if( !function_exists("receive_object", env) )
			return notify_fail("OeC\n");

		inv = all_inventory(env);
		if( !sizeof(inv) )
			return notify_fail("̭SFC\n");

		for(i=0; i<sizeof(inv); i++) {
			if( inv[i]->is_character() || inv[i]->query("no_get") ) continue;
			do_get(me, inv[i]);
		}
		write("OkC\n");
		return 1;
	}

	if( !objectp(obj = present(arg, env)) || living(obj) )
		return notify_fail("ASo˪FC\n");

	if( obj->query("no_get") )
		return notify_fail("oӪF讳_ӡC\n");
	
	return do_get(me, obj);
}
	
int do_get(object me, object obj)
{
	object old_env, *enemy, *guard;
	int equipped;

	if( !obj ) return 0;
	old_env = environment(obj);

	if( obj->is_character() ) {
		if( living(obj) ) return 0;
		//	if( !userp(obj) && !obj->is_corpse() )
		//		return notify_fail("AuItLaC\n");
		// If we try to save someone from combat, take the risk :P
	}

	notify_fail("o˪F讳XӡC\n");
	if( old_env->hold_object(obj) )	return 0;

	if( guard = obj->query_temp("guarded") ) {
		guard = filter_array(guard, (:
			objectp($1) && present($1, environment($2)) && living($1) && ($1!=$2)
			:), me);
		if( sizeof(guard) )
			return notify_fail( guard[0]->name() 
				+ "ub" + obj->name() + "@ǡMHC\n");
	}

	if( obj->query("no_get") ) return 0;
	if( me->over_encumbranced() ) return notify_fail("AwgtLFT\n");

	if( obj->query("equipped") ) equipped = 1;

	if( member_array(base_name(obj), spec_item) >= 0 )
		log_file("static/ITEM",
			sprintf("%s obtained %s on %s.\n", geteuid(me), obj->name(), ctime(time())));

	if( obj->move(me) ) {
		if( me->is_fighting() ) me->start_busy(1);
		if( obj->is_character() )
			message_vision( "$NN$nߤF_ӴbIWC\n", me, obj );
		else
			message_vision( sprintf("$N%s@%s$nC\n", 
				old_env==environment(me)? "߰_":
					(old_env->is_character() ?
						"q" + old_env->name() + "W" + (equipped? "U" : "jX"):
						"q" + old_env->name() + "X"),
				obj->query("unit")), me, obj );
		return 1;
	}
	else return 0;
}

int help(object me)
{
	write(@HELP
O榡 : get <~W> [from <eW>]
 
oӫOiHA߰_aWήeY˪~.
 
HELP
    );
    return 1;
}
 
