// kill.c

#include <ansi.h>

inherit F_CLEAN_UP;

void do_kill(object, object);

int main(object me, string arg)
{
	object obj;
	string *killer, callname;

	if( environment(me)->query("no_fight") )
		return notify_fail("o̤԰C\n");

	if( !arg )
		return notify_fail("AQ֡S\n");

	if(!(obj = present(arg, environment(me)))
	|| !obj->is_character() || obj->is_corpse() )
		return notify_fail("ǫSoӤHC\n");

	if(obj==me)
		return notify_fail("AQܡS\n");

//	if( me->is_apprentice_of(obj) )
//		return notify_fail( obj->name() + "OAvT\n");

	callname = obj->rank("rude");

	message_vision("\n$N$nܹDRu" 
		+ callname + "T餣OANOڬTv\n\n", me, obj);

	do_kill(me, obj);

	return 1;
}

void do_kill(object me, object obj)
{
	me->kill_ob(obj);
	if( !userp(obj) ) {
		if( !obj->accept_kill(me) )
			obj->kill_ob(me);
	} else {
		obj->fight_ob(me);
		tell_object(obj, HIR "pGAnM" + me->name() 
			+ "ʩR۷iMЧA]oӤHU@ kill OC\n" NOR);
	}
}

int help(object me)
{
  write(@HELP
O榡 : kill <H>
 
oӫOADʶ}l@ӤHMåB|ձMkill M fight ̤j
PbN|uMjaM]NOM|uˡCѩ kill uݳ
@[@NiHߡM]AHϥ kill O|}l԰Mq`pG
O NPC ܡML̤]|P˹Aϥ killC

HAϥ kill Oɷ|X{⪺rĵiAM@ӪaӨMpG
AS@WĤHϥιL kill OMN|Nu˩α( ϥΪkN
~)C

LO: fight

 fight  kill ϤЬ 'help combat'.
HELP
    );
    return 1;
}
 
