// wear.c

#include <ansi.h>

inherit F_CLEAN_UP;

int do_wear(object me, object ob);

int main(object me, string arg)
{
	object ob, *inv;
	int i, count;


	if( me->is_busy() )	return notify_fail("A{bSšT\n");

	if( !arg ) return notify_fail("AnS\n");

	if(arg=="all") {
		inv = all_inventory(me);
		for(count=0, i=0; i<sizeof(inv); i++) {
			if( inv[i]->query("equipped") ) continue;
			if(do_wear(me, inv[i]) ) count ++;
		}
		write("Ok.\n");
		return 1;
	}

	if( !objectp(ob = present(arg, me)) )
		return notify_fail("AWSo˪FC\n");

	if( ob->query("equipped") )
		return notify_fail("Awg˳ƵۤFC\n");

	return do_wear(me, ob);
}

int do_wear(object me, object ob)
{
	string str;

	if( ob->query("female_only")
	&&	(string)me->query("gender") != "k" )
		return notify_fail("oOkHmMA@ӤjkH]QMۤ]ۡS\n");

	if( ob->wear() ) {
		if( !stringp(str = ob->query("wear_msg")) )
			switch( ob->query("armor_type") ) {
				case "cloth":
				case "armor":
				case "boots":
					str = YEL "$NW@" + ob->query("unit") + "$nC\n" NOR;
					break;
				case "head":
				case "neck":
				case "wrists":
				case "finger":
				case "hands":
					str = YEL "$NW@" + ob->query("unit") + "$nC\n" NOR;
					break;
				case "waist":
					str = YEL "$NN@" + ob->query("unit") + "jbyC\n" NOR;
					break;
				default:
					str = YEL "$N˳$nC\n" NOR;
			}
		message_vision(str, me, ob);
		return 1;
	} else
		return 0;
}

int help(object me)
{
	write(@HELP
O榡Rwear <˳ƦW>
 
oӫOA˳ƬY󨾨C
 
HELP
    );
    return 1;
}
