// wield.c

inherit F_CLEAN_UP;

varargs int do_wield(object me, object ob);

int main(object me, string arg)
{
	string skill;
	object ob, *inv;
	int i, count;

	if( me->is_busy() ) return notify_fail("A{bSšT\n");

	if( !arg ) return notify_fail("An˳ƤZS\n");

	if(arg=="all") {
		inv = all_inventory(me);
		for(count=0, i=0; i<sizeof(inv); i++) {
			if( inv[i]->query("equipped") ) continue;
			if(do_wield(me, inv[i]) ) count ++;
		}
		write("Ok.\n");
		return 1;
	}

	// Get skill type if specified.
	sscanf(arg, "%s as %s", arg, skill);

	if( !objectp(ob = present(arg, me)) )
		return notify_fail("AWSo˪FC\n");

	return do_wield(me, ob, skill);
}

varargs int do_wield(object me, object ob, string skill)
{
	string str;

	if( ob->wield(skill) ) {
		if( !stringp(str = ob->query("wield_msg")) )
			str = "$N˳$n@ZC\n";
		message_vision(str, me, ob);
		return 1;
	} else
		return 0;
}

int help(object me)
{
	write(@HELP
O榡Rwield <˳ƦW> [as <Zޯ>]
 
oӫOA˳ƬY󪫫~@ZMAݭn֦o˪~C

ǪZiH\hاLϥΡMҦp@CiHCϡM]iHMAMAi
H

wield broadsword as sword



wield broadsword as blade

ӫwC
 
HELP
    );
    return 1;
}
