// quit.c

#include <command.h>
#include <login.h>

inherit F_DBASE;
inherit F_CLEAN_UP;

void create() 
{
	seteuid(getuid());
	set("channel_id", "uO");
}

int main(object me, string arg)
{
	int i;
	object *inv, link_ob;

	if( me->is_busy() ) {
		me->interrupt_me(me, "halt");
		write("Ok.\n");
		return 1;
	}

	if( me->query_temp("corpse") && arg != "!" )
		return notify_fail("A{b}N|hAMLk_MpGTwn}\n"
			"Х 'quit !'C\n");

	if( !wizardp(me) ) {
		inv = all_inventory(me);
		for(i=0; i<sizeof(inv); i++)
			if( !inv[i]->query_autoload() )
				DROP_CMD->do_drop(me, inv[i]);
	}

	link_ob = me->link();

	// We might be called on a link_dead player, so check this.
	if( link_ob ) {

		// Are we possessing in others body ?
		if( link_ob->is_character() ) {
			write("Az^" + link_ob->name(1) + "WC\n");
			exec(link_ob, me);
			link_ob->setup();
			return 1;
		}

		link_ob->set("last_on", time());
		link_ob->set("last_from", query_ip_name(me));
#ifdef SAVE_USER
		link_ob->save();
#endif
		destruct(link_ob);
	}

	write("wUAӡT\n");
	message("system", me->name() + "}CC\n", environment(me), me);

	CHANNEL_D->do_channel(this_object(), "sys",	me->name() + "}CFC");

#ifdef SAVE_USER
	me->save();
#endif
	destruct(me);

	return 1;
}

int help(object me)
{
	write(@HELP
O榡 : quit

A(p)QȮ}, iQΦ@OC
HELP
    );
    return 1;
}
