// analyze.c

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object ob;
	string str;
	mapping apply, weapon;

	if( !arg ) ob = me;
	else {
		if( !(ob = find_player(arg))
		&&	!(ob = present(arg, environment(me)))
		&&	!(ob = find_living(arg)) )
			return notify_fail("ǫS " + arg + " oإͪC\n");
	}

	str = sprintf("%sUORR\n\n", ob->name());
	str += sprintf("յ\t%d\n", ob->query_ability("intimidate"));
	str += sprintf("O\t\tO %dMj %d\n", ob->query_ability("attack"), ob->query_strength("attack"));
	str += sprintf("uյ\t%d\n", ob->query_ability("wittiness"));
	str += sprintf("mO\t\tO %dMj %d\n", ob->query_ability("defense"), ob->query_strength("defense"));
	str += sprintf("]O\t\tO %dMj %d\n", ob->query_ability("magic"), ob->query_strength("magic"));
	str += sprintf("kO\t\tO %dMj %d\n", ob->query_ability("spell"), ob->query_strength("spell"));
	if( mapp(weapon  = ob->query_temp("weapon")) && sizeof(weapon) ) {
		string term;
		str += "ϥΪZ\t";
		foreach(term in keys(weapon)) {
		str += sprintf("%-30s  O %+d\n\t\t", weapon[term]->name() + "(" + term + ")",
					ob->query_skill(term));
		}
	}
	else str += sprintf("{\tO %+d\n", ob->query_skill("unarmed"));

	if( mapp(apply = ob->query_temp("apply")) ) {
		string term;
		mixed prop;

		str += "\nL[O/ݩ\n";
		foreach(term, prop in apply)
			str += sprintf("  %-20s  %O\n", term, prop);
	}

	write(str);
	return 1;
}

int help()
{
	write(@TEXT
O榡Ranalyze [<H>]

oӫO|CX@ǦwHOȡMwHɫhCXAۤv
OȡC
TEXT
	);
	return 1;
}
