// breathe.c

#include <ansi.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	int kee_cost, armor;
	object victim;

	if( me->is_busy() ) return 0;
	if( !me->is_fighting() ) return notify_fail("A{bèSb԰C\n");

	kee_cost = (int)me->query_stat("kee") / 5;
	if( kee_cost < 3 )
		return notify_fail("A𤣰FC\n");

	me->consume_stat("kee", kee_cost);
	me->start_busy(1);

	message_vision(HIY "$NhFXBMMqfQX@ѪT\n" NOR, me);
	foreach(victim in me->query_enemy()) {
		if( victim->resist_attack(me->query("age") * 5, me->query("age") * 3000, me) >= me->query("age") * 5 )
			continue;
		armor = victim->query_temp("apply/armor_vs_fire");
		if( kee_cost > armor )
			victim->damage_stat("kee", random(kee_cost - armor) + 1);
	}	
	return 1;
}

int help()
{
	write(@TEXT
O榡Rbreathe

RҦĤHC
TEXT
	);
	return 1;
}
