// alchemist.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("L", ({ "chen weisha", "weisha", "chen" }));
	set("nickname", "s~h");
	set_attr("dex", 18);
	set_attr("int", 24);
	set_attr("wis", 25);
	set_attr("spi", 22);
	set_attr("cps", 19);
	set_attr("con", 20);
	set_race("human");
	set_level(25);
	set_class("alchemist");
	set_skill("unarmed", 60);
	set_skill("sword", 60);
	set_skill("parry", 80);
	set_skill("dodge", 70);
	set_skill("alchemy-medication", 140);
	set_skill("alchemy-wealth", 40);
	set_skill("alchemy-magic", 80);
	set_skill("alchemy-immortality", 30);
	set("age", 55);
	set("long",
		"LOӵۦWhMg`өѨP쳱ĤδMV\n"
		"é_qMLMF~O¤PMoX쥻nϤs\n"
		"ġMO]svhҥHȮɦb~aLټƤC\n"
		"LWסMLOLǥ̰ͭeLٸMNOL۷\n"
		"LMwꤣMYO~WlFiͤNM\n"
		"uȦXeNWϤsаshFC\n");
	setup();
	carry_object(__DIR__"obj/silversword")->wield();
	carry_object("/obj/cloth")->wear();
}

void set_flag(object me)
{
	if( present(me, environment()) ) {
		if( me->query_class() != "commoner" ) return;
		me->set_temp("pending/alchemist", 1);
	}
	else
		do_chat("LDRK ... HFMڳoY٦bۨۻy ...C\n");
}

int accept_apprentice(object me)
{
	if( is_chatting() ) return 0;
	if( me->query_temp("pending/alchemist") ) return 1;
	do_chat(({
		"LDRڬvS ... ڥiOZLrC\n",
		"L۫Υ~XF|MDRڥuOӳwҤġBꤣYC\n",
		"LMF_ӡMDRuҤġBꤣv... ...C\n",
		"LDRڬݧAo~HٶMpGAȰǿNĪʬ ...\n",
		"LDRѤҪ{UdHMKhA@Ӥ]C\n",
		(: set_flag, me :)
	}));
	return 0;
}

int init_apprentice(object me)
{
	if( ::init_apprentice(me) ) {
		me->set_class("alchemist");
		do_chat(({
			"LIFIYMDRAMJڪUMOoNĤQ~C\n",
			"LDRQ~MpGvݧAٳyNMo~ǧANC\n",
			"L\\F\\MDRnFMAUhaC\n"
		}));
	}
}

int acquire_skill(object ob, string skill)
{
	switch(skill) {
	case "alchemy-medication":
	case "alchemy-wealth":
	case "alchemy-magic":
	case "alchemy-immortality":
	default:
	}
	return 0;
}
