// child.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("_", ({ "arbao" }) );
	set_attr("spi", 18);
	set_attr("int", 19);
	set_attr("dex", 19);
	set_attr("con", 17);
	set_race("human");
	set_class("thief");
	set_level(10);

	set_skill("stealing", 40);
	set_skill("dodge", 35);
	set_skill("dagger", 40);
	set_skill("sword", 30);

	set("age", 15);
	set("gender", "female");
	set("long",
		"oӤQBphQNOu_vFMoWM۲ʥ\n"
		"AMoQOӬHFlM@LLjLLa\n"
		"ۡM٤ɨnۧAݡMϧATıoǵo~C\n");

	setup();
	carry_money("coin", 30);
	carry_object(__DIR__"obj/blue_cloth")->wear();
	carry_object(__DIR__"obj/dagger")->wield();
}

int hungry = 1;

void init()
{
	::init();
	if( is_fighting() ) return;

	if( hungry )
		do_chat((: command, "say  ... ڨ{lnjMSYS" :));
	else
		do_chat((: command, "say N ... OCCDڦbo ..." :));
}

private void give_comb(object player)
{
	object comb;

	if( !player || environment(player)!=environment() ) {
		command("say x ... HOS");
		return;
	}
	comb = new(__DIR__"obj/comb");
	comb->move(this_object());
	command("give comb to " + player->query("id"));
}

private void exchange(string food_name, object player)
{
	set_stat_current("food", 0);
	command("eat " + food_name);
	if( !player || environment(player) != environment() ) return;

	command("say F ... ӥզYAFMoӰeAaT");
}

int accept_object(object me, object ob)
{
	if( !hungry || !inherits(F_FOOD, ob) ) {
		do_chat((: command, "say ڳoӷFS" :));
		return 0;
	}

	hungry = 0;
	command("smile");
	command("say  .. ӦnFTu§AT ...");
	do_chat(({ (: exchange, ob->query("id"), me :), (: give_comb, me :) }));

	return 1;	
}
