// gammer.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("MѤӱC", ({ "blind gammer", "gammer" }) );
	set_attr("dex", 23);
	set_attr("con", 21);
	set_attr("cor", 22);
	set_race("human");
	set_class("thief");
	set_level(44);

	set_skill("staff", 40);
	set_skill("stealing", 70);
	set_skill("dodge", 90);
	set_skill("blade", 30);
	set_skill("sword", 30);
	set_skill("unarmed", 50);
	set_skill("dagger", 70);
	set_skill("secondhand dagger", 70);

	set("gender", "female");
	set("age", 66);
	set("long",
		"@ӽMFѤӱCMyKMOoH@ؿˤPıC\n");
	set("chat_chance", 8);
	set("chat_msg", ({
		"MѤӱCaDR_SOAܡS\n",
		"MѤӱCۦզGbťC\n",
		(: random_move :)
	}) );
	set("chat_chance_combat", 10);
	set("chat_msg_combat", ({
		"MѤӱCsDR_TcHbۭtCCT֥XӰڡT\n",
		(: random_move :),
	}) );
	set_stat_notify("kee", 40);

	setup();
	carry_object(__DIR__"obj/cloth")->wear();
	carry_object(__DIR__"obj/cane")->wield();
	carry_object(__DIR__"obj/syndicator")->wield("secondhand dagger");
}

void relay_say(object ob, string arg)
{
	if( arg=="" && ob->query_temp("thief_qualified") ) {
		command("giggle");
		command("pat " + ob->query("id"));
		if( (string)ob->query_class() != "commoner" ) return;
		ob->set_class("thief");
		tell_object(ob, "A@WsFC\n");
		return;
	}

	if( strsrch(arg, "_") >= 0 )
		do_chat((: command, "say _SA_b̡S" :));
	else switch(random(10)) {
		case 0: do_chat((: command, "shake" :));
		case 1: do_chat((: command, "?" :));
		case 2: do_chat((: command, "steal coin from " + ob->query("id") :));
	}
}

int accept_fight()
{
	do_chat((: command, "?" :));
	return notify_fail("MѤӱCAYL@ ...C\n");
}

void init()
{
	// Dont call original init() to check autofight.
}

private void ask_join(object player)
{
	if( !player || environment(player)!=environment() ) return;

	if( player->query_class() != "commoner" )
		command("say  ... HѤFMsHޤl``ᱼC\n");
	else {
		command("whisper " + player->query("id") + 
			" nåMMAhFSQpOOSsڤ@nuv ...");
		player->set_temp("thief_qualified", 1);
	}
}

int accept_object(object player, object ob)
{
	if( !ob->id("annatto comb") ) return 0;

	command("say xSo ... oO ... ڪޤlT");
	do_chat((: ask_join, player :));
	return 1;
}
