// girl.c

#include <npc.h>

inherit F_FIGHTER;

object *dest = ({});

void create()
{
	set_name("զkl", ({ "girl" }) );
	set_attr("con", 21);
	set_attr("str", 19);
	set_attr("spi", 22);
	set_attr("int", 20);
	set_attr("dex", 24);
	set_race("human");
	set_class("fighter");
	set_level(55);

	set_skill("sword", 100);
	set_skill("dodge", 100);
	set_skill("parry", 100);
	set_skill("blade", 70);
	set_skill("dagger", 70);

	set("age", 19);
	set("gender", "female");
	set("long",
		"@Өզ窺klMݰ_Ӧ~|WLGQMeƬMo\n"
		"O@FqMOHMVC\n" );
	setup();
	carry_object(__DIR__"obj/white_dress")->wear();
	carry_object(__DIR__"obj/slasher_sword")->wield();
}

void relay_emote(object ob, string verb)
{
	do_chat((: command, "shake" :));
}

void attack_intruder(object ob)
{
	if( !ob || member_array(ob, dest)==-1 ) return;
	dest -= ({ ob });
	if( environment(ob) != environment() ) return;
	command("say AuOnRFT\n");
	kill_ob(ob);
	ob->fight_ob(this_object());
}

void listen_request(object ob)
{
	set("pending_requester", ob);
	command("hmm");
	command("say AQnSaC");
}

int accept_object(object who, object ob)
{
	if( ob->id("bronze hairpin") ) {
		command("say o ... oOڪv¯TٵڡT");
		dest -= ({ who });
		if( is_fighting(who) ) {
			remove_killer(who);
			who->remove_killer(this_object());
		}
		do_chat( (: listen_request, who :) );
		return 1;
	} else {
		command("say oO}KS}T");
		return 0;
	}
}

void drop_invitation()
{
	object ob;

	command("say TڹDOSFֺuaT");
	ob = new(__DIR__"obj/invitation");
	ob->move(this_object());
	command("drop invitation");
	delete("pending_requester");
}

void relay_say(object ob, string msg)
{
	if( ob==this_object() ) return;
	if( ob != query("pending_requester") ) 
		do_chat((: command, "say ǫSAܪlaMڳLT":));
	else {
		if( msg!="^" ) {
			do_chat((: command, "say oتFڨSM@ءT" :));
			return;
		}
		do_chat((: drop_invitation :));
	}
}

void init()
{
	::init();
	if( this_player() && (!this_player()->query_temp("hairpin_quest")) ) {
		do_chat((: command, "say AO֡SuTuXhTMڱFAT" :));
		if( member_array(this_player(), dest)==-1 ) {
			dest += ({ this_player() });
			call_out((: attack_intruder, this_player() :), 5);
		}
	}
}
