// guard.c

#include <npc.h>

inherit F_VILLAGER;

void create()
{
	set_name("C~l", ({"guard"}));
	set_attr("str", 20);
	set_attr("con", 20);
	set_race("human");
	set_class("fighter");
	set_level(20);

	set_skill("sword", 70);
	set_skill("blade", 50);
	set_skill("parry", 50);
	set_skill("unarmed", 40);
	set_skill("dodge", 70);

	set("age", 26);
	set("long", "@ӨëCl˪~lMجanۧAC\n");
	setup();
	carry_object(__DIR__"obj/cloth")->wear();
	carry_object(__DIR__"obj/longsword")->wield();
	carry_money("coin", 160);
}


void init()
{
	::init();
	add_action("do_go", "go");
}

// This overrides standard "go" command to emulate the effect of guarding
// an entry.
int do_go(string arg)
{
	// Only checks eastward movement, returning 0 to let standard command
	// process it.
	if( (arg!="east")
	|| this_player()->query_class()=="fighter"
	|| !this_player()->visible(this_object())
	)
		return 0;

	do_chat((: command, "say 藍_MDOMu^QȤ~JC":));
	write( name() + "dFAhC\n");
	return 1;
}


void greet_visitor(object ob, object invitation)
{
	destruct(invitation);
	if( environment(ob)!=environment() ) return;

	message_vision(name() + "޻$NLFMiJuC\n", ob);
	ob->move("/d/snowkeep/entrance");
}

int accept_object(object who, object ob)
{
	if( !ob->id("invitation") ) return 0;

	command("say pHqTͲDwgԦhɤFC\n");
	do_chat((: greet_visitor, who, ob :));
	return 1;
}
