// lieutenant.c

#include <npc.h>

inherit F_SOLDIER;

void create()
{
	set_name("Zx", ({ "lieutenant" }) );
	set_attr("con", 21);
	set_attr("str", 22);
	set_race("human");
	set_class("fighter");
	set_level(24);

	set_skill("twohanded sword", 80);
	set_skill("blade", 60);
	set_skill("unarmed", 65);
	set_skill("parry", 60);
	set_skill("dodge", 70);

	set("age", 36);
	set("long", "oO@WxLZxML̳q`OxHX޵Ѫ˳˳̡C\n");
	set("vendetta_mark", "authority");
	set("bounty/martial art", 250);
	set("bounty/martial mastery", 150);
	setup();
	carry_object(__DIR__"obj/cloth")->wear();
	carry_object(__DIR__"obj/leather_armor")->wear();
	carry_object(__DIR__"obj/helmet")->wear();
	carry_object(__DIR__"obj/clothboot")->wear();
	carry_object(__DIR__"obj/broadsword")->wield();
}

void init()
{
	::init();
	add_action("intercept", "go");
}

int intercept(string arg)
{
	if( (arg!= "north") || !this_player()->visible(this_object()) ) return 0;

	write( name() + "NAdFUӡC\n");
	do_chat((: command, "say Ϥs̪񦳵sXSMĄOaC":) );
	return 1;
}

int accept_fight(object ob)
{
	do_chat((: command, "emote FMDRu}u}T֦booT":));
	return 0;
}
