// waiter.c

#include <npc.h>

inherit F_VILLAGER;
inherit F_VENDOR;

int on_service = 0;

void create()
{
	set_name("pG", ({ "waiter", "snow_inn_waiter" }) );
	set_race("human");
	set_class("commoner");
	set_level(2);

	set("age", 21);
	set("long",
		"@ӬGQXY~p٭pMiX۩IȤHMAiH\n"
		"list ݥiHIM buy 򩱤pGIC\n");
	set("chat_chance", 4);
	set("chat_msg", ({
		"pG۵LM_pӡC\n",
		"pGYXhFѦMDRoXѤѮ𤣿MuQXhC\n",
		"pGDRѪͤDnIFSM֤FѪo̹beC\n",
		"pGDRȭѫ򦳪šM̪isAƯ໡ťťܡS\n",
	}));
	set("merchandise", ([
		__DIR__"obj/dumpling": 50,
		__DIR__"obj/manto": 50,
		__DIR__"obj/pork": 30,
		__DIR__"obj/roast_chicken": 30
	]));

	setup();
}

void init()
{
	::init();
	add_action("do_vendor_list", "list");
}


int accept_fight(object ob)
{
	do_chat("pGFӰyMDRȭn[ܡMpڥiOC\n");
	return 0;
}

mixed affirm_merchandise(object customer, string item_name)
{
	if( on_service )
		return notify_fail("pG۩۩ILȤHMЧA@|C\n");
	return ::affirm_merchandise(customer, item_name);
}

private void handover(object customer, mixed item)
{
	on_service = 0;
	if( !customer || environment(customer)!=environment() ) {
		command("say xS診ȭHOSIFHSF ...");
		say("pGݥXӪ" + item->name() + "SݤF^hC\n");
		return;
	}
	command("say ȭMz" + item->name() + "ӰաT");
	message_vision("$NqpкݥXӪ" + item->name()
		+ "e$neC\n", this_object(), customer);
	::deliver_merchandise(customer, item);
}

void deliver_merchandise(object customer, mixed item)
{
	command("say " + item->name() + "OaSWӡT");
	say("pGۼpг۹DR" + item->name() + "@T\n");
	on_service = 1;
	do_chat((: handover, customer, item :));
}
