// bandage.c

inherit ITEM;
inherit F_EQUIP;

void create()
{
	set_name("", ({ "cloth piece", "cloth", "piece" }) );
	set_weight(200);
	if( clonep() )
		set_default_object(__FILE__);
	else {
		set("unit", "");
		set("material", "cloth");
		set("armor_type", "bandage");
		set("armor_prop/attack", -10);
		set("armor_prop/defense", -10);
		set("armor_prop/unarmed", -10);
	}
}

void init()
{
	add_action("do_bandage", "bandage");
}

int wear() { return 0; }

int do_bandage(string arg)
{
	object ob;

	if( (int)query("blood_soaked") >= 2 )
		return notify_fail( name() + "wgQAzMAΤFC\n");

	if( query("equipped") )
		return notify_fail( name() + "wgqbAˤfWFMpGAnΨӥ]ϧOHMЧA⥦UӡC\n");

	if( !arg ) ob = this_player();
	else {
		ob = present(arg, environment(this_player()));
		if( !ob || !ob->is_character() )
			return notify_fail("AnֻqˡS\n");
	}

	if( this_player()->is_fighting()
	||	ob->is_fighting() )
		return notify_fail("԰qˡC\n");

	if( (int)ob->query("eff_kee") == (int)ob->query("max_kee") )
		return notify_fail( (ob==this_player()? "A" : ob->name())
			+ "èS~ˡC\n");

	if( ob->query_temp("armor/bandage") )
		return notify_fail( ob->name() + "WˤwgqۨLFFC\n");

	if( !move(ob) ) return 0;

	if( ob==this_player() )
		message_vision("$N" + name() + "ۤvqˡC\n", this_player());
	else
		message_vision("$N" + name() + "$nqˡC\n", this_player(), ob);

	::wear();
	ob->apply_condition("bandaged", 40);
	add("blood_soaked", 1);

	return 1;
}

void remove(string euid)
{
	::remove(euid);
	if( query("equipped") && environment() )
		environment()->apply_condition("bandaged", 0);
}

string query_autoload()
{
	if( query("equipped") ) return query("name");
}

void autoload(string arg)
{
	int i;

	set("name", arg);
	set("blood_soaked", 3);
	::wear();
}

