// corpse.c

inherit ITEM;

int decayed;

void create()
{
	set_name("LW", ({ "corpse" }) );
	set("long", "oO@LWC\n");
	set("unit", "" );
	decayed = 0;
if( clonep(this_object()) ) call_out("decay", 240, 1);
}

int is_corpse() { return decayed < 2; }
int is_character() { return decayed < 1; }

string short() { return name() + "(" + capitalize(query("id")) + ")"; }

void decay(int phase)
{
	decayed = phase;
	switch(phase) {
		case 1:
			say( query("name") + "}lGFMoX@DcC\n" );
			switch(query("gender")) {
				case "male":
					set_name("Gꪺk", ({ "corpse", "" }) );
					break;
				case "female":
					set_name("Gꪺk", ({ "corpse", "" }) );
					break;
				default:
					set_name("Gꪺ", ({ "corpse", "" }) );
					break;
			}
			set("long",	"oMwgbo̦@qɶFMoۤ@ѻGͪDC\n");
			call_out("decay", 120, phase + 1);
			break;
		case 2:
			say( query("name") + "QjFMܦ@eC\n" );
			set_name("\\e", ({ "skeleton", "e" }) );
			set("long", "oewgbo̫ܤ[FC\n");
call_out("decay", 180, phase + 1);
			break;
		case 3:
			say( "@}jLM" + query("name") + "ƦǧjFC\n" );
			if( environment() ) {
				object *inv;
				int i;
				
				inv = all_inventory(this_object());
				for(i=0; i<sizeof(inv); i++) inv[i]->move(environment());
			}
			destruct(this_object());
			break;
	}
}

int receive_object(object oob, int from_inventory) { return 1; }
