// fight.c

#include <ansi.h>
#include <char.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object obj, old_target;

	if( !wizardp(me) && environment(me)->query("no_fight") )
		return notify_fail("o̸T԰C\n");

	if(!arg || !objectp(obj = present(arg, environment(me))))
		return notify_fail("AQ֡S\n");

	if( !obj->is_character() )
		return notify_fail("ݲM@IMäOͪC\n");

	if( me->is_apprentice_of(obj) )
		return notify_fail( obj->name() + "OAvT\n");

	if( obj->is_fighting(me) )
		return notify_fail("[oT[oT[oT\n");

	if( !living(obj) && inherits(F_ATTACK, obj) )
		return notify_fail(obj->name() + "wgLk԰FC\n"); 

	if(obj==me)	return notify_fail("AۤvC\n");

	if( userp(obj) && (object)obj->query_temp("pending/fight")!=me ) {
		message_vision("\n$N$nDR" 
			+ me->rank("self") + me->name() + "Mгo"
			+ obj->rank("respectful") + "ۡT\n\n", me, obj);
		if( objectp(old_target = me->query_temp("pending/fight")) )
			tell_object(old_target, YEL + me->name() + "FMAժYC\n" NOR);
		me->set_temp("pending/fight", obj);
		tell_object(obj, YEL "pGA@NMiաMЧA]" + me->name() + "("+(string)me->query("id")+")"+ "U@ fight OC\n" NOR);
		write(YEL "ѩOѪaHMAPN~iաC\n" NOR);
		return 1;
	}

	if( obj->query("civilized") ) {
		message_vision("\n$N$nDR" 
			+ me->rank("self")
			+ me->name() + "Mгo"
			+ obj->rank("respectful") + "ۡT\n\n", me, obj);

		notify_fail("ݰ_" + obj->name() + "äQAqC\n");
		if( !userp(obj) && !obj->accept_fight(me) ) return 0;

		me->fight_ob(obj);
		obj->fight_ob(me);
	} else {
		message_vision("\n$Njܤ@nM}l$noʧT\n\n", me, obj);
		me->fight_ob(obj);
		obj->kill_ob(me);
	}

	return 1;
}
int help(object me)
{
  write(@HELP
O榡 : fight <H>
 
oӫOAV@ӤHuQСvΪ̬OuRZvMoاΦ԰ºO
I쬰M]u|OM|uˡMOäOҦ  NPC w
[M]ݦhpAZnD|QڵC
 
LO: kill

PS. pG褣@NADԡMAMiHw kill O}l԰M
     fight  kill ϤЬ 'help combat'.
HELP
    );
    return 1;
}
 
