// team.c

#include <ansi.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object *t;

	if( !arg ) {
		if( !pointerp(t = me->query_team()) )
			return notify_fail("A{bèSѥ[󶤥C\n");
		write("A{bR\n  " + implode(t->short(1), "\n  ") + "\n");
		return 1;
	}

	if( arg=="dismiss" ) {
		if( !pointerp(t = me->query_team()) )
			return notify_fail("A{bèSѥ[󶤥C\n");
		if( me->is_team_leader() ) {
			message("team", me->name(1) + "NѴFC\n", t, me);
			write("ANѴFC\n");
		} else {
			message("team", me->name(1) + "MwC\n", t, me);
			write("AFAC\n");
		}
		me->dismiss_team();
		return 1;
	}

	if( sscanf(arg, "with %s", arg)==1 ) {
		object ob;

		if( !(ob = present(arg, environment(me)))
		||	!living(ob)
		||	!ob->is_character()
		||	ob==me )
			return notify_fail("AQM֦٦S\n");

		if( !pointerp(me->query_team()) || me->is_team_leader() ) {
			if( me==(object)ob->query_temp("pending/team") ) {
				if( !pointerp(me->query_team()) ) {
					ob->add_team_member(me);
					message_vision("$NMw[J$nC\n", me, ob);
				} else {
					me->add_team_member(ob);
					message_vision("$NMw$n[JC\n", me, ob);
				}
				ob->dellete_temp("pending/team");
				return 1;
			} else {
				message_vision("$Nܽ$n[J$PC\n", me, ob);
				tell_object(ob, YEL "pGA@N[JMХ team with " + me->query("id") + "C\n" NOR);
				me->set_temp("pending/team", ob);
				return 1;
			}
		} else
			return notify_fail("uSiHܽЧOH[JC\n");
	}

	if( sscanf(arg, "talk %s", arg)==1 ) {
		if( !pointerp(t=me->query_team()) )
			return notify_fail("A{bèSMOHզC\n");
		message("team", HIW "ij" + me->name(1) + "R" + arg + "\n" NOR, t);
		return 1;
	}

	if( sscanf(arg, "form %s", arg)==1 ) {
		if( !pointerp(t=me->query_team()) || !me->is_team_leader() )
			return notify_fail("AO@ӶS~´}ΡC\n");
		if( !me->query_skill(arg, 1) )
			return notify_fail("oذ}ΧASǹLC\n");
		return SKILL_D(arg)->form_array(me);
	}
}

int help(object me)
{
	write(@HELP
OϥΤk:

team with <YH> - YHզ. n賣PN[J~|ͮġC
team dismiss     - }. YUOOⶤ, hӶ|ѴC
team talk <T> - 򶤥̨LH͸, iH tt <T> NC
team form <}k> - pGⶤǹL}kܡMiHN´
                   Yذ}ΡMզ}ΪAunS@ʴN|ѰC

U team Oɫh|ܧAثeO_[JζWC

: team  follow OWߪMA@wn follow SC
HELP
	);
	return 1;
}
