// skills.c

#include <ansi.h>

inherit F_CLEAN_UP;

string *skill_level_desc = ({
	"ǥEm",
	"ʳq֤",
	"bͤ",
	"",
	"rN",
	"X޵",
	"G",
	"XJ",
	"npy",
	"@Nvv",
	"`i"
});

string *knowledge_level_desc = ({
	"sǥE",
	"s|",
	"@G",
	"",
	"wp",
	"߻⯫|",
	"FM",
	"ŵMeq",
	"|@L",
	"_jव",
	"`i"
});

string skill_level(string, int);

int main(object me, string arg)
{
	object ob;
	mapping skl, lrn, map;
	string *sname, *mapped, s, old_s;

	seteuid(getuid());

	if(!arg) ob = me;
	else {
		ob = present(arg, environment(me));
		if (!ob) ob = find_player(arg);
		if (!ob) ob = find_living(arg);
		if (!ob) return notify_fail("Anݽ֪ޯS\n");
		if( !wizardp(me)
		&&	!ob->is_apprentice_of(me)
		&&	!me->is_apprentice_of(ob)
		&&	!ob->accept_info(me, "skills") )
			return notify_fail("uŮvΦv{YHݥLHޯC\n");
	}

	skl = ob->query_skills();
	if( !mapp(skl) ) skl = ([]);
	lrn = ob->query_learned();
	if( !mapp(lrn) ) lrn = ([]);

	if(!sizeof(skl) && !sizeof(lrn)) {
		write( (ob==me ? "A" : ob->name()) + "ثeèSǷ|ޯC\n");
		return 1;
	}

	write( (ob==me ? "A" : ob->name()) +"ثeҾǹLޯR\n\n");
	sname  = sort_array( keys(skl) + keys(lrn), 1 );
	
	map = ob->query_skill_map();
	if( mapp(map) ) mapped = values(map);
	if( !mapped ) mapped = ({});

	foreach(s in sname) {
		if( s==old_s ) continue;
		printf("%s%-40s" NOR " - %-10s %3d/%8d %s\n", 
			(member_array(s, mapped)==-1? "  ": ""),
			to_chinese(s) + " (" + s + ")",
			skill_level(SKILL_D(s)->type(), skl[s]),
			skl[s], lrn[s],
			(!undefinedp(map[s]) ? ("[" + ob->query_skill(s) + "]") : "")
		);
		old_s = s;
	}
	write("\n");
	return 1;
}

string skill_level(string type, int level)
{
	int grade;

	grade = sqrt(level/3);

	switch(type) {
		case "knowledge":
			if( grade >= sizeof(knowledge_level_desc) )
				grade = sizeof(knowledge_level_desc)-1;
			return knowledge_level_desc[grade];
		default:
			if( grade >= sizeof(skill_level_desc) )
				grade = sizeof(skill_level_desc)-1;
			return skill_level_desc[grade];
	}
}

int help(object me)
{
	write(@HELP
O榡 : skills [<YH>]

oӫOiHA(p)dߩҾǹLޯC

A]iHw@өMAv{YHM skills iHd誺ޯબpC

ŮviHdߥH NPC ޯબpC

HELP
    );
    return 1;
}
