// update.c

#include "/doc/help.h"

inherit F_CLEAN_UP;

int update_player(object me);

int main(object me, string file)
{
	int i;
	object obj, *inv;
	string err;

	seteuid( geteuid(me) );

	if (!file) file = me->query("cwf");
	if (!file)
		return notify_fail("AnssĶɮסS\n");

	if( (obj = present(file, environment(me))) && interactive(obj) )
		return update_player(obj);

	if( file == "me" )
		return update_player(me);
	else {
		file = resolve_path(me->query("cwd"), file);
		if( !sscanf(file, "%*s.c") ) file += ".c"; 
	}

	if( file_size(file)==-1 )
		return notify_fail("SoɮסC\n");

	if( file==__FILE__ ) {
		write("U@ϥ update ON|ssĶ update OC\n");
		destruct(this_object());
		return 1;
	}

	me->set("cwf", file);

	if (obj = find_object(file)) {
		if( obj==environment(me) ) {
			if( file_name(obj)==VOID_OB )
				return notify_fail("Ab VOID_OB ̭ssĶ VOID_OBC\n");
			inv = all_inventory(obj);
			i = sizeof(inv);
			while(i--)
				if( userp(inv[i]) ) {
					inv[i]->set_temp("last_location", file);
					inv[i]->move(VOID_OB, 1);
				}
				else inv[i] = 0;
		}
		destruct(obj);
	}

	if (obj) return notify_fail("LkMµ{XC\n");

    write("ssĶ " + file + " ...\n");
	err = catch(obj = load_object(file));

	if(!err) {
		write("Ok.\n");
		i = sizeof(inv);
		while(i--)
			if( inv[i] && userp(inv[i]) ) inv[i]->move(obj, 1);
	} else {
		write("sĶѡR" + err);
	}
		
	return 1;
}

int update_player(object me)
{
	object env, link_ob, obj;

	env = environment(me);

	link_ob = me->link();
	if( !link_ob ) {
		// If update a linkdead player, simply destruct it.
		me->save();
		seteuid(getuid());
		destruct(me);
		return 1;
	}

	if( !(obj = LOGIN_D->make_body(link_ob)) )
		return notify_fail("Lkƻss骫T\n");

	exec(link_ob, me);

	// Make a careful check before copying body.
	if( (string)me->query_save_file() == (string)obj->query_save_file() ) {
		me->save();
		obj->restore();
	}
	seteuid(getuid());
	destruct(me);

	LOGIN_D->enter_world(link_ob, obj, 1);

	write("sC\n\n");
	obj->move(env);
	obj->write_prompt();

	return 1;
}

int help(object me)
{
  write(@HELP
O榡 : update <ɦW|here|me|aW>
 
oӫOiHsɮ, ñNsɪeJO餺. YؼЬ
'here' hsҦb. YؼЬ 'me' hsۤvH. Y
Ьahisa.
 
HELP
    );
    return 1;
}
 
