// demogorgon.c

#include <npc.h>

void create()
{
	set_name("³TǤH", ({"black figure", "figure"}));
	set_race("human");
	set_class("fighter");
	set_attr("str", 32);
	set_attr("dex", 30);
	set_attr("cor", 33);
	set_attr("cps", 39);
	set_attr("int", 35);
	set_attr("spi", 48);
	set_attr("wis", 39);
	set_attr("con", 28);
	set_level(90);
	advance_stat("gin", 300);
	advance_stat("kee", 200);
	advance_stat("sen", 500);
	set_skill("unarmed", 190);
	set_skill("blade", 200);
	set_skill("dodge", 120);
	set_skill("parry", 150);
	set("long",
		"@Ө³TǤHAuSXOJ㪺biyAݤX߫s\n"
		"AbLeA@ػXiAGoӤH}xA@\n"
		"AOAûsLuؤ]ݤC\n");
	setup();
	carry_object(__DIR__"obj/black_spark")->wield();
}

void enable_trade(object ob)
{
	if( !ob || environment(ob) != environment() ) return;
	ob->set_temp("pending/trade_karma", 1);
}

void init()
{
	if( !this_player() || is_fighting() || is_chatting() ) return;
	if( !this_player()->link() ) return;
	if( this_player()->link()->query("karma") < 10 ) return;
	do_chat(({
		"³TǤHauyvF@nC\n\n", 1, 1, 1,
		"³TǤHDGSO@ӥiå ... AۥhLܡH\n\n", 1, 
		"³TǤHnŪŬ}}AUۦaUhC\n\n",
		"³TǤHDG͡BѡBfB ...  KKKK ... uhWڡH\n\n", 1, 1, 1,
		"³TǤHaĤFfADGQXU~·t_ ... C\n\n",
		"³TǤHFXnAMLӡAAMݤLAOAD\n"
		"LnۧAݡC\n\n", 1, 1, 1, 1,
		"³TǤHDGnaAڦAQnAAڷQnAӭӥpH\n\n",
		(: enable_trade, this_player() :)
	}));
}

void trade_karma(object ob)
{
	if( !ob || environment(ob) != environment() ) return;
	if( !ob->link() ) return;
	seteuid(geteuid(ob));
	ob->link()->add("karma", -10);
	ob->set("life_preservation", 3);
	seteuid(getuid());
}

void relay_say(object ob, string msg)
{
	if( !ob->query_temp("pending/trade_karma") ) return;
	if( strsrch(msg, "") >= 0) {
		command("hmm");
		command("say ڥunA@yܡAunv٬OunvC");
		return;
	}
	else if( strsrch(msg, "·t") >= 0 ) {
		command("say ... ǨƱA٬ODn ...");
		return;		
	}
	else if( strsrch(msg, "") >= 0 ) {
		command("nod");
		command("say ]ѱoA ...");
		ob->delete_temp("pending/trade_karma");
		return;
	}
	else if( strsrch(msg, "n") >= 0 ) {
		command("nod");
		command("say ݨӧAAѧABҡAϥA]SiHlMF ... KKC\n\n");
		ob->delete_temp("pending/trade_karma");
		do_chat(({
			"³TǤHyF@yAwwaKUL ...\n\n",
			"Aݨ³TǤH᭱ .... MŵL@TDLOΪS\n\n", 1, 1,
			"³TǤHSF_ӡAMAݤLyAOonGM\n"
			"hF ....\n\n", 1, 1, 1,
			"³TǤH|_ӡAoX@}uP_ǭ`AOƤ]So ...\n\n",
			(: trade_karma, ob :),
			"³TǤHIFIYASNF^h ...\n\n",
			"³TǤHDGܦnANoˡAAiHF ...\n\n",
			"(ݼˤl³TǤHwgFLһuvAOAèSıoܤ)\n\n"
		}));
		return;
	}
}

int accept_fight(object ob)
{
	command("say ڤQ[AN⥴[]|AC");
	return 0;
}

void real_fight(object ob)
{
	if( !ob ) return;
	if( environment(ob)==environment() ) {
		command("grin");
		map_skill("unarmed", "unarmed");
		command("charge " + ob->query("id"));
	}
}

void accept_kill(object ob)
{
	map_skill("unarmed", "none");
	do_chat(({
		"³TǤHDG.... uOMåC\n",
		"³TǤHDGo˧aAڼƨTAk] ...\n",
		"³TǤHDG@ ...\n",
		"³TǤHDGG ...\n",
		"³TǤHDGTI\n",
		(: real_fight, ob :)
	}));
}
