// foreman.c

#include <npc.h>

inherit F_VILLAGER;

void new_crate();


void create()
{
	set_name("uY", ({ "foreman" }) );
	set_race("human");
	set_level(8);
	set_stat_maximum("kee", 60);
	set_attr("str", 18);
	set_attr("cor", 19);
	set_attr("cps", 15);
	set_attr("dex", 16);

	set("age", 48);
	set("long",
		"oNOoaf̪uYMtduHNfhihXMpG\n"
		"AQuȨǿMiHLͽͬݡC\n");
	set("chat_chance", 10);
	set("chat_msg", ({
		(: new_crate :),
		"uYjn[ܵۤuHNfqܮwhXӡC\n",
		"uYjsRpOSѦSӡS\n",
		"uYDR֦AhhǤHMMFC\n",
		"uYDRnu@ӭӨ ... O ...\n"
	}) );
		
	setup();
	carry_money("coin", 220);
}

int accept_fight()
{
	do_chat("uYDRZSAƤFܡSڤ~Sض\\ҡC\n");
	return 0;
}

void relay_say(object me, string msg)
{
	if( is_fighting() || is_chatting() ) return;

	if( strsrch(msg, "u") >= 0 ) {
		int amount;
		object money;

		if( amount = me->query_temp("wage_deserved") ) {
			money = new("/obj/money/coin");
			money->set_amount(amount);
			money->move(this_object());
			command("say nMn ... `@O" + chinese_number(amount) + "MMAC");
			me->delete_temp("wage_deserved");
			do_chat((: command, "give coin to " + me->query("id"):));
		}
		else do_chat("uYDRh@ӽclMlaߤTC\n");
		return;
	}
}

void new_crate()
{
	object ob;
	
	if( !environment()
	||	sizeof(all_inventory(environment())) >= 15 ) return;

	ob = new(__DIR__"obj/crate");
	ob->move(environment());
	say("uYDRޡTfpߤ@IMOLaFT\n");
}
