// herbalist.c

#include <npc.h>

inherit F_VILLAGER;
inherit F_VENDOR;

void create()
{
	set_name("ľQxd", ({"herbalist"}));
	set_race("human");
	set_class("alchemist");
	set_level(3);
	set_skill("unarmed", 5);
	set_skill("parry", 5);
	set_skill("dodge", 5);
	set_skill("dagger", 5);

	set("age", 44);
	set("long",
		"ľQxdODD~klMM~|QFMLݰ_\n"
		"Ө̵MB믫صoMAiH list ݥL̦ġC\n");

	set("merchandise", ([
		"/obj/drug/black_pill": 50,
		"/obj/drug/boar_berry": 40,
		"/obj/drug/wild_ginseng": 30,
		"/obj/drug/dragon_saliva": 20,
	]));

	setup();
	carry_object(__DIR__"obj/cloth")->wear();
	carry_object(__DIR__"obj/fur_hat")->wear();
}

void init()
{
	::init();
	add_action("do_vendor_list", "list");
}
