// blunt.c

#include <ansi.h>

inherit SKILL;

mapping *actions = ({
    ([  "action":		"$N$wM$n$l{FLh",
        "damage_type":  "",
	]),
     ([  "action":		"$NR⤤$wMuIv@n$n$lY{U",
        "damage_type":  "",
	]),
    ([  "action":       "$N_⤤$wMӷ$w$laNLh",
        "damage_type":  "",
	]),
    ([  "action":       "$NuKva@nM۰_⤤$w$n$lĤO@",
        "damage_type":  "",
	]),
    ([  "action":      "$NN$wϵoFʤlM̵ۤ@Zl$n$lFLh",
        "damage_type":  "",
	]),
});

string *interattack = ({
	"$N򴤵ۤ⤤$nMӰʡC\n",
	"$NN⤤$nRoIITC\n",
});

void create()
{
	seteuid(getuid());
	DAEMON_D->register_skill_daemon("blunt");
	DAEMON_D->register_skill_daemon("secondhand blunt");
	DAEMON_D->register_skill_daemon("twohanded blunt");
	setup();
}

varargs void attack_using(object me, object opponent, object weapon)
{
	int damage;
	string skill;

	if( !sscanf(weapon->query("equipped"), "weapon/%s", skill) )
		return;

	if( !opponent ) {
		if( me->query_temp("last_attacked_target"))
			message_vision(CYN + interattack[random(sizeof(interattack))] + NOR,
				me, weapon);
		return;
	}
	damage = COMBAT_D->fight(me, opponent, skill,
		actions[random(sizeof(actions))], weapon);

	if( damage > 0 ) me->improve_skill(skill, 1 + random(me->query_attr("int")));
}

void skill_improved(object me, string sk)
{
	int skill, learn;

	if( !sk ) sk = "blunt";

	skill = me->query_skill(sk, 1);
	learn = me->query_learn(sk, 1);

	if( (skill<90) && (skill+1) * (skill+1) * 100 < learn ) {
		me->advance_skill(sk, 1);
		me->gain_score("martial art", (skill+1) * 10 );
	}
}
