// dagger.c

#include <ansi.h>

inherit SKILL;

mapping *actions = ({
	([	"action":		"$N_⤤$wrM$n$lh",
		"damage_type":	"",
	]),
	([	"action":		"$N$wM$n$lFLh",
		"damage_type":	"ζ",
	]),
	([	"action":		"$N򴤤⤤$wM$n$lFLh",
		"damage_type":	"",
	]),
	([	"action":		"$Nʤ⤤$wMdV$n$l",
		"damage_type":	"ζ",
	]),
});

string *interattack = ({
	"$N򴤵ۤ⤤$nMwwaʸ}BC\n",
	"$NnHvaN$nqkߨ쥪MSqߨkC\n",
	"$NinզaRۤ⤤$nMϤ޻XۡC\n",
});

void create()
{
	seteuid(getuid());
	DAEMON_D->register_skill_daemon("dagger");
	DAEMON_D->register_skill_daemon("secondhand dagger");
	setup();
}

varargs void attack_using(object me, object opponent, object weapon)
{
	int damage;
	string skill;

	if( !sscanf(weapon->query("equipped"), "weapon/%s", skill) )
		return;

	if( !opponent ) {
		if( me->query_temp("last_attacked_target"))
			message_vision(CYN + interattack[random(sizeof(interattack))] + NOR,
				me, weapon);
		return;
	}

	damage = COMBAT_D->fight(me, opponent, skill,
		actions[random(sizeof(actions))], weapon);
	if( damage > 0 ) me->improve_skill(skill, 1 + random(me->query_attr("int")));
}

void skill_improved(object me, string sk)
{
	int skill, learn;

	if( !sk ) sk = "dagger";
	else if( sk!="dagger" && sk!="secondhand dagger" ) return;

	skill = me->query_skill(sk, 1);
	learn = me->query_learn(sk, 1);

	if( (skill<90) && (skill+1) * (skill+1) * 90 < learn ) {
		me->advance_skill(sk, 1);
		me->gain_score("martial art", (skill+1) * 10 );
	}
}
